#include "Const.h"
#include "Generale.h"
#include "Soldato.h"
#include "Conjunto.h"
#include "Controllabili.h"
#include <iostream>
#include <cstdlib>
#include <cmath>

using namespace std;





/* Ordens Complexas */ 
int Controllabili::eseSpotare(int *x, int *y){
	int dx=0, dy=0, sx, sy;
	int tx = *x, ty = *y;	


	sx = *x - this->x;
	sy = *y - this->y;

	// Verifica se chegou no destino
	if ( sx*sx + sy*sy <= 2 ){
		return 3;
	}

if ( ( val_atacar > 400 ) ||  ( val_defender > 300 ) ){
	eseLibero ();
	return 0;	
}
	        
	if ((gnrl->getHeight(tx,ty) != -1 ) && !gnrl->isMove( tx, ty)){
		GetRandRun(&tx, &ty);
		*x = *x + tx;
		*y = *y +ty;
	}

	sx = *x - this->x;
	sy = *y - this->y;
	
	if ( !standing ){
		stand();
		return 0;
	}

   // Encontra o vetor da direcao
	dx = dy = 0;
	if ( sx == 0 ){
		dy = (sy > 0)?1:-1;
	} else if ( sy == 0){
		dx = (sx > 0)?1:-1;
	} else {
		dx = (sx > 0)?1:-1;
		dy = (sy > 0)?1:-1;
	}

	// Verifica se pode andar
	proxMove (&dx,&dy,sx,sy);
	run (this->x+dx,this->y+dy);
	return 0;
}

int Controllabili::eseSpotare(int x, int y, int limit, int back){// verificar se o calculo está correto
		int dx, dy, sx, sy;
      sx = x - this->x;
		sy = y - this->y;

        // Verifica se chegou no destino
        if ( sqrt (sx*sx + sy*sy) <= limit ){
               		return 5;
        }
        if ( !standing ){
                stand();
                return 0;
        }
 	
        // Encontra o vetor da direcao
        dx = dy = 0;
        if ( sx == 0 ){
                dy = (sy > 0)?1:-1;
        } else if ( sy == 0){
                dx = (sx > 0)?1:-1;
        } else {
                dx = (sx > 0)?1:-1;
                dy = (sy > 0)?1:-1;
        }

        // Verifica se pode andar
        proxMove (&dx,&dy,sx,sy);

	// Verifica se o boneco ficará sobre o limite	
	if ( back && this->x+dx == x && this->y+dy == y){
		if ( dy == 0 )	
			(dx > 0)? dx-- : dx++ ;
		else	
			(dy > 0)? dy-- : dy++ ;
		
		if( standing ) run  (this->x+dx,this->y+dy);
		else           crawl(this->x+dx,this->y+dy);
		
		return 0;
	}
		
	
        
        run (this->x+dx,this->y+dy);

        return 0;
}


int Controllabili::esePickup (unsigned int hold_tipo){
	int qtde[] = {0,1,2,3,1,1,1,2,3,0,0,0,0,0,0,0,0,0,0,0};
	int bola[] = {0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0};

	// Terminou
	if ( holding == hold_tipo || hold_tipo > HOLD_L || holding > HOLD_L){
		return 2; 
	}	

	// Restricao 1 -> Nao pode ter mais neve do que o necessario
	if ( qtde[holding] > qtde[hold_tipo] ){
		int rx, ry;
		GetRandCrawl (&rx, &ry);
		drop ( x+rx, y+ry );
		return 0;
	}
		

	// Restricao 2 -> Precisa ser possivel pegar neve solta
	if ( !isPickup () ){
		eseLibero ();
		return 0;
	}
	
	// Passo 2 -> Pegar Neve
	if ( qtde[holding] < qtde[hold_tipo] ){
		// Passo 2.1 -> Abaixar
		if ( standing ) {
			crouch ();
			return 0;
		}

		int rx=rand()%2-1, ry=rand()%2-1, i;
		char ground = gnrl->getGround (this->x+rx,this->y+ry);
		for (i=0; i<8 && ground != GROUND_SMB && ground != GROUND_S; i++){
			vetAdd (&rx,&ry,1);
			ground = gnrl->getGround (this->x+rx,this->y+ry);
		}
		if ( i < 8 ){
			pickup (this->x+rx,this->y+ry);
			return 0;
		}

		for (i=0; i<8 && !gnrl->isPickup(this->x+rx,this->y+ry); i++)
			vetAdd (&rx,&ry,1);
		if(i >= 8){
			GetRandCrawl (&rx, &ry);
			crawl(this->x+rx,this->y+ry);
		} else
			pickup (this->x+rx,this->y+ry);

		return 0;
	}

	// Passo 3 -> Fazer a Bola de Neve
	if ( bola[hold_tipo] ){
		crush();
		return 0;
	}

	return 0;
}


#define BOLA_PEQUENA 1
#define BOLA_MEDIA 2
#define BOLA_GRANDE 4
// Pega neve uma qtde de neve e coloca num lugar ao redor do controllabili 
int Controllabili::eseBuild (int x, int y, int hold_tipo, int bola_tipo){
	// Terminou
	int ground2bola[] = {0,0,0,1,2,3,4,6,5,7,6,0,0,0,0,0};
	unsigned char ground = gnrl->getGround(x,y) + 1;

	if ( ground <= 10 && ( ground2bola[ ground ] & bola_tipo ) == bola_tipo ){
		return 4;
	} 
	ground++;

	// Restricao 1 -> Deve ser Possivel Construir

	// Passo 1 -> Ir até o lugar
	if ( !eseSpotare (x,y,1,1) ){
		return 0;
	}

	// Passo 2 -> Pegar Neve
	if ( !esePickup (hold_tipo) ){
		return 0;		
	} 

	// Restricao 2 -> Nao deve estar no lugar onde vai construir
	if ( this->x == x && this->y == y){
		GetRandCrawl (&x, &y);
		if ( standing ) {
			crouch ();
			return 0;
		}	
		crawl ( this->x+x, this->y+y);
		return 0;
	}

	// Passo 3 -> Colocar a Neve
	/*if ( holding == HOLD_L && ground != GROUND_LM){
		int rx, ry;
		GetRandCrawl (&rx, &ry);
		drop ( x+rx, y+ry );
		return 0;
	} else */
		drop ( x , y );
	return 0 ;
}


// Constroi um boneco na posicao x,y
int Controllabili::eseBuildBoneco(int *x, int *y){
	// Terminou
	for (int yy=-1; yy<2; yy++) for (int xx=-1; xx<2; xx++){
		if ( gnrl->getGround(this->x+xx, this->y+yy) ==  GROUND_L ){
			*x = this->x+xx;
			*y = this->y+yy;
			break;
		}
	}

	int tx = *x;
	int ty = *y;

	if ( gnrl->getGround(tx,ty) == GROUND_SMR )
		return 3;	


	// Restricao 1 -> Tem uma Arvore no Local
	if ( gnrl->getGround(tx,ty) == GROUND_TREE){
		GetRandRun(x, y);
		return 0;
	}

	// Passo 1 -> Constroi a bola grande
	if ( !eseBuild (tx,ty,HOLD_L, BOLA_GRANDE) ){
//cerr << "constroi bola grande\n";
		return 0;

}
	// Passo 2 -> Constroi a bola media
	if ( !eseBuild (tx,ty,HOLD_M,BOLA_MEDIA) )
		return 0;

	// Passo 3 -> Constroi a Cabeca
	eseBuild (tx,ty,HOLD_S1,GROUND_SMR);
	
	return 0;
}


// Rouba boneco inimigo na posicao x,y
int Controllabili::eseRubareBoneco(int nivel,int x, int y){
	if ( pc[nivel] == 0 ){			// Anda até o lugar
		if ( eseSpotare (x,y,1,1) ) 
			pc[nivel]++;
	} else if ( pc[nivel] == 1 ){			// Pega a cabeça
		if( standing ) { crouch(); return 0; }
		pickup (x,y);
		regs[nivel][0]= x;
		regs[nivel][1]= y;
		pc[nivel]++;
	} else if( pc[nivel] == 2 ){             // Coloca de volta
		drop (regs[nivel][0],regs[nivel][1]);
		pc[nivel] = PC_TERMINOU;
		return 3;
	}
	return 0;
}


// Ataca um inimigo com a certeza de acertá-lo
int Controllabili::eseAttaccare( int id_nem ){
	// Pega uma Bolinha	
	if ( !(holding <= HOLD_S3 && holding >= HOLD_S1) ){
		esePickup ( HOLD_S1 );
		return 0;
	} 
	
	// Movimenta para Perto do Inimigo
	int nem_x, nem_y;
	gnrl->getNemico(id_nem)->getPos(&nem_x, &nem_y);
	if ( !eseSpotare (nem_x,nem_y,15,1) ){
		return 0;
	}

	if ( ( val_atacar < 400 ) && ( val_defender < 300 ) ){
		nem_x += rand()%8-4;
		nem_y += rand()%8-4;
		if ( !eseSpotare (nem_x,nem_y,8,1) )
		return 0;	
	}

	// Atira
	int xfim, yfim;
	if( gnrl->deffAttac(this->id, id_nem, &xfim, &yfim) ){
		gettare(xfim,yfim);
		return 3;			
	} else {
		// Desvia do Obstaculo
		nem_x += rand()%4-2;
		nem_y += rand()%4-2;
		if ( !eseSpotare (nem_x,nem_y,7,1) )
			return 0;	
	}


/*cerr << "TESTE\n";
	int rx, ry;

	if ( standing ){
		GetRandRun (&rx, &ry);
		run(this->x+rx, this->y+ry);
	} else {
		GetRandCrawl (&rx, &ry);	
		crawl (this->x+rx, this->y+ry);
	}*/
	return 0;
}



// Primeira tentativa para uma estratégia artificial
int Controllabili::eseLibero(){
	

	if ( !decisao_jahcalc ) {
		for (int yy=-3; yy<4; yy++) for (int xx=-3; xx<4; xx++){
			int px = this->x+xx, py=this->y+yy;
			int ground = gnrl->getGround(px,py);
			if ( ground == GROUND_SMB && val_defender < 400){
				eseBuildBoneco( &px, &py);
				gnrl->setGround (px,py, GROUND_AMICO);
				return 0;
			}			

			if ( ground ==  GROUND_LM && val_defender < 400){
				eseBuildBoneco( &px, &py);
				//gnrl->setGround (px,py, GROUND_AMICO);
				return 0;
			}
		}
	} 
	
	if ( val_defender < 300 )
		return 1;


	int escolha = EscolheAtacaOuDefende () ;	

	if ( escolha < 0 ){
		int tx, ty;
		gnrl->getNemico(id_defender)->getPos (&tx, &ty);
		afferrare (tx, ty);		
	} else if ( escolha >= 0 ){
		if (id_atacar >= 0)
			eseAttaccare(id_atacar);
	}
	
	return 0;
}
