#include <malloc.h>
#include "Conjunto.h"
#include <cstdio>

Conjunto::Conjunto(int tamX, int tamY){
	int y;
	this->tamX = this->tamY = 0;
	valores = (int **) calloc (tamY,sizeof(int*));
	if (valores){
		for ( y=0; y<tamY; y++)
			valores[y] = (int *) calloc (tamX,sizeof(int));
		this->tamX = tamX;
		this->tamY = tamY;
	}
}

	
void Conjunto::setAllValor (int valor){
	int x,y;
	for (y=0; y<tamY; y++)
		for (x=0; x<tamX; x++)
			valores[y][x] = valor;
}


int Conjunto::getMax (int *pvalor, int *lin, int *col ){
	int x,y,valor;
	if (tamX>0 && tamY>0){
		valor = valores[0][0];
		*lin = *col = 0;
	}

	for (y=0; y<tamY; y++)
		for (x=0; x<tamX; x++)
			if ( valores[y][x]>=valor ){
				*lin = y;
				*col =x;
				valor = valores[y][x];
			}

	*pvalor = valor;
}


int Conjunto::getMaxCol (int col){
	int y,valor;
	if (tamX>0 && tamY>0){
		valor = valores[0][0];
	}

	for (y=0; y<tamY; y++)
		if ( valores[y][col]>=valor ){
			valor = valores[y][col];
		}

	return valor;
}


int Conjunto::clrLinCol(int lin, int col){
	int i;
	
	for( i = 0; i< tamX; i++) valores[lin][i] = -1;
	for( i = 0; i< tamY; i++) valores[i][col] = -1;
	
	return 0;
}


int Conjunto::clrLin(int lin){
	int i;
	for( i = 0; i< tamX; i++) valores[lin][i] = -1;	
	return 0;
}


int Conjunto::clrCol(int col){
	int i;
	for( i = 0; i< tamY; i++) valores[i][col] = -1;
	return 0;
}


int Conjunto::divCol(int col){
	int i;
	for( i = 0; i< tamY; i++) 
		if (valores[i][col] != -1)
			valores[i][col] = valores[i][col]>>1;
	return 0;
}


int Conjunto::setValor (unsigned int x, unsigned int y, int valor){
	if ( y<tamY && x<tamX ){
		valores[y][x] = valor;
	} else 
		fprintf (stderr,"fora da matriz\n");
}


int Conjunto::getValor (unsigned int x, unsigned int y){
	if ( y<tamY && x<tamX ){
		return valores[y][x];
	} else 
		fprintf (stderr,"fora da matriz\n");
}


void Conjunto::mostrar (){
	int x,y;
	for (y=0; y<tamY; y++){
		for (x=0; x<tamX; x++)
			fprintf (stderr,"%d ",valores[y][x]);
		fprintf (stderr,"\n");
	}
}





