#include "Generale.h"
#include "Soldato.h"
#include "Conjunto.h"
#include "Controllabili.h"
#include <iostream>
#include <string>
#include <cstdlib>
#include <cmath>
using namespace std;

/* Manter a variavel ordini com a mesma ordem dos ORDEM_.... */
string ordini[] = {"idle","crouch","stand","crush","run","crawl","pickup","throw","catch","drop"};


int vetAdd (int *x, int *y, int soma);


Controllabili::Controllabili (int id, Generale *gnrl){
	int i;
	code = NULL;
	for (i=0; i<MAX_SUBNIVEIS; i++)
		pc[i] = 0;

	this->gnrl = gnrl;
	this->id = id;
	ant.num = ordem.num = 0;
	acertoubolinha = pegoubolinha = catoubolinha = 0;
}


int Controllabili::eseguire(){
	if (!code){
		idle();
	} else if (!dazed){
		int prox = 1;
		idle();
		if ( eseLibero() ){

			for (int i=0; i<3 && prox; i++){		
				switch (*code){	
					case ORDEM_INATTIVO:    prox = idle(); break;
					case ORDEM_SPOSTARE:	prox = eseSpotare( (code+1), (code+2) ); break;
					case ORDEM_BUILD:   prox = eseBuild(*(code+1), *(code+2), *(code+3), *(code+4)); break;
					case ORDEM_BUILD_BONECO:    prox = eseBuildBoneco((code+1), (code+2)); break;
					case ORDEM_LIBERO: prox = eseLibero(); break;
					case ORDEM_CROUCH:  prox = crouch(); break;
					case ORDEM_STAND:	prox = stand(); break;
					case ORDEM_RUN: prox = run(*(code+1), *(code+2)); break;
					case ORDEM_CRAWL:   prox = crawl(*(code+1), *(code+2)); break;
					case ORDEM_PICKUP:  prox = pickup(*(code+1), *(code+2)); break;
					case ORDEM_CRUSH:   prox = crush(); break;
					case ORDEM_GETTARE: prox = gettare(*(code+1), *(code+2)); break;
					case ORDEM_AFFERRARE:   prox = afferrare(*(code+1), *(code+2)); break;
					case ORDEM_DROP: prox =    drop(*(code+1), *(code+2)); break;
					case ORDEM_PICKIP: prox =  esePickup (*(code+1)); break;
					case ORDEM_ATTACCARE: prox =    eseAttaccare(*(code+1)); break;
					case ORDEM_RUBARE: prox =    eseRubareBoneco(0,*(code+1), *(code+2)); break;
					default: idle(); prox = 0;
				}
				if ( ordem.num != ORDEM_LIBERO)
					code += prox;
			}

			if ( ordem.num == ORDEM_INATTIVO ){
				if (id_atacar >= 0)
					eseAttaccare(id_atacar);
			}
		}

	}
}
	

void Controllabili::setCode (int *code){
	this->code = code;
}
	
void Controllabili::setNemicoAtacar (int id_atacar, int val_atacar){
	this->id_atacar = id_atacar;
	this->val_atacar = val_atacar;
}

void Controllabili::setNemicoDefender (int id_defender, int val_defender){
	this->id_defender = id_defender;
	this->val_defender = val_defender;
}

void Controllabili::readInfo (){
	string token;
	cin >> token;
	char ch;
	x = atoi( token.c_str() );
	cin >> y;
	cin >> ch;
	standing = ( ch == 'S' );
	cin >> ch;
	setHolding ( ch - 'a' );
	cin >> dazed;
	decisao = liberdade = decisao_jahcalc = 0;
	if ( (gnrl->getTurn()%15) == 0){
		acertoubolinha = catoubolinha = 0;
		pegoubolinha = 2;
	}
	val_atacar = 0;
	val_defender = 0;
}


void Controllabili::analise (){
	if ( ant.num == ORDEM_GETTARE && id_atacar != -1 ){
		if (  gnrl->getNemico(id_atacar)->getDazed() == 4 ){
			acertoubolinha++;
			catoubolinha--;
		} else if ( gnrl->getNemico(id_atacar)->isGanhouBolinha() ){
			catoubolinha++;										// Atingiu, mas segurou
		}
	} 

	if ( ant.num == ORDEM_AFFERRARE ){
		if ( isGanhouBolinha() ){
			pegoubolinha++;
		} else
			pegoubolinha--;
	}
	id_atacar = id_defender = -1;
	val_atacar = val_defender = -1;
}


void Controllabili::sendOrdine (){
	if ( ordem.num > ORDEM_MAX ){
		cout << ordini[ORDEM_INATTIVO] << endl;
	} else {
		cout << ordini[ordem.num] << endl;
		//cerr << id << " " << ordini[ordem.num] << " " ;
		if ( ordem.num >= ORDEM_SEM_PARAM ){
			cout << ordem.x << " " << ordem.y << endl;
			//cerr << ordem.x << " " << ordem.y;
		}
		//cerr << endl;
	}
	ant.num = ordem.num;
	ant.x = ordem.x;
	ant.y = ordem.y;
	ordem.num = ORDEM_INATTIVO;
	endturn = FALSE;
}


int  Controllabili::isAcertouBolinha (){
	return acertoubolinha;
}


/* Ajusta as coordenadas relativas 
	x>=100 -> soldato.x + (x-100) 
	x>=200 -> soldato.x - (x-100)
	Vale o mesmo para o y 
*/
void Controllabili::ajustar (int *x, int *y){
	int tx = *x, ty = *y;
	if (tx>=100){
		if (tx>=200)	tx = this->x - ( tx-200 );
		else	tx = this->x + tx-100;
	}
	if (ty>=100){
		if (ty>=200)	ty = this->y - ( ty-200 );
		else	ty = this->y + ty-100;
	}
	*y = ty;
	*x = tx;
}



/* -1 >= x >= 1 e -1 >= y >= 1 */ 
int vetAdd (int *x, int *y, int soma){
	int trans[] = {0,1,2,7,-1,3,6,5,4};
	int posX[] = {-1,0,1,1,1,0,-1,-1};
	int posY[] = {1,1,1,0,-1,-1,-1,0};
	int rx = *x, ry = *y;
	int pos = trans[(4-ry*3+rx)%9];
	*x = posX[(pos+soma)%8];
	*y = posY[(pos+soma)%8];
	return 0;
}


int Controllabili::getPoderAtaque (){
	if ( !standing && holding == HOLD_EMPTY )
		return 1;

	if ( holding == HOLD_P1 )
		return 2;

	if ( holding >= HOLD_S1 && holding <= HOLD_S3 )
		return 3;
	return 0;
}

int Controllabili::GetRandSpotare(int *x, int *y){
	int i , tx= *x, ty= *y, exp, ok = 0;
	
	for(i = 1; !ok; i++){
		for(exp = 1; !gnrl->isMove(tx, ty) && exp <= i*i*2 ; exp++){  
			tx = *x + rand()%(i*2) - i;
			ty = *y + rand()%(i*2) - i;
		 }
		if( exp <= i*i*2 ) ok = 1; 
	}
		
	*x = tx;
	*y = ty;
}
 
int Controllabili::GetRandRun (int *rx, int *ry){
	int i, pos;
	int posX[] = {-1,0,1,1,1,0,-1,-1};
	int posY[] = {1,1,1,0,-1,-1,-1,0};
	
	for (i=0; i<7; i++){
		int tx, ty;
		pos = rand() % 8;
		tx = posX[pos];
		ty = posY[pos];
		posX[pos] = posX[i];
		posY[pos] = posY[i];
		posX[i] = tx;
		posY[i] = ty;
	}

	for (i=0; i<7 && !gnrl->isMove(this->x+posX[i],this->y+posY[i]); i++)
		;

	*rx = 0;
	*ry = 0;
	if ( i < 8 ){
		*rx = posX[i];
		*ry = posY[i];
	} else
		cerr << "ERROR: RandRun() " << endl;	

	return 0;
}


int Controllabili::GetRandCrawl (int *rx, int *ry){
	int i, pos;
	int posX[] = {0,1,0,-1};
	int posY[] = {1,0,-1,0};
	
	for (i=0; i<4; i++){
		int tx, ty;
		pos = rand() % 4;
		tx = posX[pos];
		ty = posY[pos];
		posX[pos] = posX[i];
		posY[pos] = posY[i];
		posX[i] = tx;
		posY[i] = ty;
	}

	for (i=0; i<4 && !gnrl->isMove(this->x+posX[i],this->y+posY[i]); i++)
		;

	*rx = 0;
	*ry = 0;
	if ( i < 4 ){
		*rx = posX[i];
		*ry = posY[i];
	} else {
		idle();
	}
	return 0;
}



int abs(int x){ if( x >= 0 ) return x; else return -x; }


/* Retorna o proximo movimento do boneco considerando possiveis barreiras
        Entrada:
                Vetor direcao dx,dy
                O quanto falta para o destino, sx, sy
        Saida:
                Atualizados valores de dx e dy
*/
void Controllabili::proxMove (int *dxx, int *dyy, int sx, int sy){
        int dx = *dxx;
        int dy = *dyy;
        if ( gnrl->isMove (this->x+dx,this->y+dy) ){
                if ( ( dx == 0 || dy == 0 ) && ( abs(sx) > 1 || abs(sy) > 1 ) && ( gnrl->isMove (this->x+dx<<1,this->y+dy<<1) ) ){
                        dx = dx << 1;
                        dy = dy << 1;
                }
        } else {
                vetAdd (&dx,&dy,1);
                if (gnrl->isMove (this->x+dx,this->y+dy)){
                        if ( ( dx == 0 || dy == 0 ) && ( abs(sx) > 1 || abs(sy) > 1 ) && ( gnrl->isMove (this->x+dx<<1,this->y+dy<<1) ) ){
                                dx = dx << 1;
                                dy = dy << 1;
                        }
                } else {
                        vetAdd (&dx,&dy,-2);
                        if (gnrl->isMove (this->x+dx,this->y+dy)){
                                if ( ( dx == 0 || dy == 0 ) && ( abs(sx) > 1 || abs(sy) > 1 ) && ( gnrl->isMove (this->x+dx<<1,this->y+dy<<1) ) ){
                                        dx = dx << 1;
                                        dy = dy << 1;
                                }
                        } else {
                                vetAdd (&dx,&dy,-1);
                                if (gnrl->isMove (this->x+dx,this->y+dy)){
                                        if ( ( dx == 0 || dy == 0 ) && ( abs(sx) > 1 || abs(sy) > 1 ) && ( gnrl->isMove (this->x+dx<<1,this->y+dy<<1) ) ){
                                                dx = dx << 1;
                                                dy = dy << 1;
                                        }
                                } else {
                                        vetAdd (&dx,&dy,4);
                                        if (gnrl->isMove (this->x+dx,this->y+dy)){
                                                if ( ( dx == 0 || dy == 0 ) && ( abs(sx) > 1 || abs(sy) > 1 ) && ( gnrl->isMove (this->x+dx<<1,this->y+dy<<1) ) ){
                                                        dx = dx << 1;
                                                        dy = dy << 1;
                                                }
                                        }
                                }
                        }
                }
        }
        *dxx = dx;
        *dyy = dy;
}

