#ifndef CONTROLLABILI_H
#define CONTROLLABILI_H


#include "Conjunto.h"



#define	ORDEM_SEM_PARAM 4
#define	ORDEM_MAX		9

/* ORDENS de 0 - 9 estão em Soldato.h */
#define	ORDEM_SPOSTARE 10				// mover para x,y
#define	ORDEM_PICKIP 11
#define	ORDEM_BUILD 12					// mover neve x,y,qtde de neve(1-3),forma(0-neve solta, 1-bola de neve)
#define	ORDEM_BUILD_BONECO	13		// contruir boneco x,y
#define	ORDEM_ATTACCARE	14			// Ataca uma posicao x,y
#define  ORDEM_RUBARE 15				// rouba boneco inimigo na posicao x, y
#define  ORDEM_LIBERO 16
#define  ORDEM_FIM 0xff


#define MAX_SUBNIVEIS 10
#define MAX_PARAM 10

#define FALSE 0
#define TRUE 1

#define PC_TERMINOU 0

struct ordine {
	int num;
	int x,y;
};


class Generale;
int vetAdd (int *x, int *y, int soma);


class Controllabili: public Soldato {
	private:
			int *code;
			int pc[MAX_SUBNIVEIS];
			int regs[MAX_SUBNIVEIS][MAX_PARAM];
			int endturn;
			ordine ordem, ant;
			Generale *gnrl;
			int  id_atacar, id_defender;
			int val_atacar, val_defender;
			int decisao_jahcalc, decisao, liberdade;	// Decisao= Ataca, Defende ou Livre; Liberdade é a quantidade de turnos livres
	
			int acertoubolinha, pegoubolinha, catoubolinha;

	public:
		/* Construtora */
        Controllabili (int id, Generale *gnrl);

		/* Analisa e seta uma ordem a ser enviada ao icypc */
			int eseguire();

		/* Seta */
			void setCode (int *code);
			void setNemicoAtacar   (int id_atacar, int val_atacar);
			void setNemicoDefender (int id_defender, int val_defender);
			void readInfo ();
			void analise ();

		/* Envia a ordem ao icypc */
			void sendOrdine ();			

		/* Calculos de Decisoes */
			// Calculo o melhor inimigo a atacar
			void Calc_AttacaNemico (Conjunto *conjunto);	
			void Calc_DifesaNemico (Conjunto *conjunto);
			int  EscolheAtacaOuDefende ();

		/* Flags */
			int  isAcertouBolinha ();
			int  getPoderAtaque ();
			int  GetRandSpotare(int *x, int *y);
			int  GetRandRun (int *rx, int *ry);
			int  GetRandCrawl (int *rx, int *ry);
			
	private:
		/* Ordens Primitivas */
        int idle ();
        int crouch ();
        int stand ();
        int run (int x, int y);
        int crawl (int x, int y);
        int pickup (int x, int y);
        int crush ();
        int gettare (int x, int y);
        int afferrare (int x, int y);
        int drop (int x, int y);

		/* Ordens Complexas */
			// Andar até um lugar x,y
			int eseSpotare(int *x, int *y);		

			// Andar até um lugar x,y até atingir um limit
			int eseSpotare(int x, int y, int limit, int back);	

			// Pega uma quantidade de neve
			int esePickup (unsigned int hold_tipo);

			// Pegar uma quantidade de neve (qtde) e colocar em um lugar x,y com a forma de bola ou neve solta (bola)
			int eseBuild (int x, int y, int hold_tipo, int bola_tipo);
			
			// Constroi um boneco x,y
			int eseBuildBoneco(int *x, int *y);

			// Rouba boneco na posicao x, y
			int eseRubareBoneco(int nivel, int x, int y);

			// Ataca um inimigo
			int eseAttaccare(int id_nem);

			// Ataca uma posicao x,y	

			// Tentativa da estratégia
			int eseLibero();

		/* Rotinas Auxiliares */
			// Ajusta a posicao relativa x e y 
			void ajustar (int *x, int *y);

			void proxMove (int *dxx, int *dyy, int sx, int sy);

	/*OBS: o parametro nivel indica o nivel da pilha em que a rotina está sendo executada*/
};


#endif
