#include "Const.h"
#include "Conjunto.h"
#include "Generale.h"
#include "Soldato.h"
#include "Controllabili.h"
#include "Nemico.h"
#include <iostream>
#include <cstdlib>
#include <cmath>

using namespace std;



/*=================================== S C R I P T ======================================*/

int ia_p0[] = {	
		ORDEM_BUILD_BONECO,9,12,	
	//ORDEM_SPOSTARE,9,12,
		ORDEM_LIBERO,
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p1[] = {
		ORDEM_SPOSTARE,18,12,
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p2[] = { 
		ORDEM_BUILD_BONECO,20,7,
		ORDEM_SPOSTARE,21,10,
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p3[] = {
		ORDEM_BUILD_BONECO,7,7,
		ORDEM_SPOSTARE,14,11,
		ORDEM_LIBERO,
		ORDEM_FIM
};

//-------------------


int ia_p01[] = {	
		ORDEM_SPOSTARE,9,18,	
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p11[] = {
		ORDEM_SPOSTARE,13,20,
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p21[] = { 
		ORDEM_SPOSTARE,16,17,
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p31[] = {
		ORDEM_SPOSTARE,18,20,
		ORDEM_LIBERO,
		ORDEM_FIM
};


//---------------------------


int ia_p02[] = {	
		ORDEM_SPOSTARE,19,25,	
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p12[] = {
		ORDEM_SPOSTARE,23,23,
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p22[] = { 
		ORDEM_SPOSTARE,26,21,
		ORDEM_LIBERO,
		ORDEM_FIM
};


int ia_p32[] = {
		ORDEM_SPOSTARE,22,20,
		ORDEM_LIBERO,
		ORDEM_FIM
};




/*--------------------------------------------------------------------------------------*/


#define GROUND_VAZIO 0


/*================================== C O D I G O =======================================*/


/* Construtor */
Generale::Generale (){
	int i;
	for (i=0; i<CCOUNT; i++){
		amico[i] = new Controllabili (i, this);
		nemico[i] = new Nemico (i, this);
	}
	pc = 0;
	score[ RED ]  = redConquista  = redBatalha  = 0;
	score[ BLUE ] = blueConquista = blueBatalha = 0;

	amico[0]->setCode (ia_p0);
	amico[1]->setCode (ia_p1);
	amico[2]->setCode (ia_p2);
	amico[3]->setCode (ia_p3);
}


/* Lê o turno do Programa icypc.jar */
int Generale::readTurn (){
	cin >> turn;
	return turn;
}


/* Lê as Informações do Programa icypc.jar */ 
void Generale::readInfo (){

	// Lê a Pontuação
	int redscore, bluescore, difredscore, difbluescore;
	cin >> redscore >> bluescore;
	difredscore = redscore - score[ RED ];
	difbluescore = bluescore - score[ BLUE ];
	score[ RED ] = redscore; 
	score[ BLUE ] = bluescore;

	// Lê o campo
	for ( int i = 0; i < SIZE; i++ ){
		for ( int j = 0; j < SIZE; j++ ) {
			char a, b;
			cin >> a >> b;
			if ( a != '*' ) {
				height[ i ][ j ] = a - '0';
				ground[ i ][ j ] = b - 'a';
			} else {
				height[ i ][ j ] = -1;
				ground[ i ][ j ] = -1;
			}
		}	
	}

	// Lê os dados dos amigos
	varpeso = rand() % 100;
	forcaaliada = forcainimiga = 0;
	for ( int i = 0; i < CCOUNT; i++ ){
		int x,y;
		amico[i]->readInfo ();
		amico[i]->getPos (&x,&y);
		ground[x][y] = GROUND_AMICO;
		if ( amico[i]->isGettare() )
			forcaaliada++;

		if ( amico[i]->isAttaccato() ){
			blueBatalha += 10;
			difbluescore -= 10;
		}
	}
	
	// Lê os dados do inimigo
//cerr << "Inimigos" << endl;
	for ( int i = 0; i < CCOUNT; i++ ){
		int x,y;
		nemico[i]->readInfo ();
		nemico[i]->getPos (&x,&y);
		ground[x][y] = GROUND_NEMICO;
		if ( nemico[i]->isGettare() )
			forcainimiga++;

//cerr << "Poder de Ataque igual a " << nemico[i]->getPoderAtaque() << endl;
		if ( nemico[i]->isAttaccato() ){
			redBatalha += 10;
			difredscore -= 10;
		}
	}

	// Verifica o Status do Controllabilis
	for ( int i = 0; i < CCOUNT; i++ ){
		amico[i]->analise ();
	}

	// Calcula a Pontuacao de Conquista
	if ( difredscore == 10 || difredscore == 20 || difredscore == 30){
		redBatalha += difredscore;
	} else
		redConquista += difredscore;

	if ( difbluescore == 10 || difbluescore == 20 || difbluescore == 30){
		blueBatalha += difbluescore;
	} else
		blueConquista += difbluescore;	
/*cerr << "Pontuação: "<< endl;
cerr << "C " << redConquista << "  G " << redBatalha << endl;
cerr << "C " << blueConquista << "  G " << blueBatalha << endl << endl;*/
}
	




/* Analisa a situacao e decidi as novas estrategias */	
void Generale::analise (){
	if ( turn > 60 && redConquista<blueConquista ){
		amico[0]->setCode (ia_p02);
		amico[1]->setCode (ia_p12);
		amico[2]->setCode (ia_p22);
		amico[3]->setCode (ia_p32);
	}



	Conjunto ataque (CCOUNT, CCOUNT);
	Conjunto defesa (CCOUNT, CCOUNT);
	for( int k = 0; k < CCOUNT ; k++){
		amico[k]->Calc_AttacaNemico ( &ataque );
		amico[k]->Calc_DifesaNemico ( &defesa );
	}

	int idNemico, idAmico, val;
	defesa.getMax(&val, &idAmico, &idNemico);
	while ( val != -1 ){
		amico[idAmico]->setNemicoDefender (idNemico, val);
		defesa.clrLin(idAmico);
		defesa.divCol(idNemico);
		defesa.getMax(&val, &idAmico, &idNemico);
	}

	ataque.getMax(&val, &idAmico, &idNemico);
	while ( val != -1 ){	
		amico[idAmico]->setNemicoAtacar (idNemico, val);
		ataque.clrLin(idAmico);
		if ( amico[idAmico]->EscolheAtacaOuDefende () > 0 )
			ataque.divCol(idNemico);
		ataque.getMax(&val, &idAmico, &idNemico);
	}

	// Manda os Soldados Executarem as Taticas e colocar no buffer a ordem a ser executada no turno
	int i;
	for (i=0; i<CCOUNT; i++)
		amico[i]->eseguire();
}






/* Envia os Comandos para Programa icypc.jar */
void Generale::writeInfo (){
	int i;
	for (i=0; i<CCOUNT; i++)
		amico[i]->sendOrdine();
}



/* Retona se pode ou nao pode pegar neve no local x e y */
int  Generale::isPickup (unsigned int x,unsigned int y){
	if ( x < SIZE && y < SIZE ){
		int chao   = (int) ground[x][y];
		int altura = (int) height[x][y];
		if ( altura > 0 && ( chao == GROUND_EMPTY || chao == GROUND_SMB ))
			return 1;
	}
	return 0;
}


/* Retona se pode ou nao se mover para o local x e y */
int  Generale::isMove (unsigned int x, unsigned int y){
	if ( x < SIZE && y < SIZE ){
		int chao   = ground[x][y];
		int altura = height[x][y];
		if ( altura < 6 && ( chao == GROUND_EMPTY || chao == GROUND_S  ))
			return 1;
	}
	return 0;
}


/* Retorna em xdest ydest a posicao para atacar o inimigo */
int Generale::deffAttac(int idAmico, int idNemico, int *xdest, int *ydest){
	
	int dx, dy, pAx, pAy, pNx, pNy, dTx, dTy;
	int distQuad, xtest, ytest, x, y, distT;
	
	float fator; // cerr<< "amico ---------------- "<< idAmico << endl;  
	
	this->amico[idAmico]->getPos(&pAx, &pAy);
	this->nemico[idNemico]->getPos(&pNx, &pNy);

	dx = pNx - pAx;
	dy = pNy - pAy;

	distQuad = dx*dx + dy*dy;  //  cerr<< "posAmico ("<<pAx <<","<<pAy<<") --------- posNemoco (" <<pNx <<","<<pNy<< ")   dx/dy  "<<dx<<"/"<<dy<<endl;

	if( this->amico[idAmico]->getStand() && !this->nemico[idNemico]->getStand() && distQuad < 49 ) 
		fator = 3;
   	else
		fator = sqrt((float)576/distQuad); 

	xtest = pAx + roundthis(dx*fator);
	ytest = pAy + roundthis(dy*fator);  //cerr<<" <> fator " << fator <<endl;


	for(y = ytest -1; y <= (ytest + 1); y++)
		for(x = xtest -1; x <= (xtest + 1); x++){

			dTx = x - pAx;
			dTy = y - pAy;
			distT = dTx*dTx + dTy*dTy;  //cerr<< "posTest ("<<x <<","<<y<<") \n";
			
			if( distT <= 576 && isAttac(idAmico, idNemico, x, y) ){
				//cerr<< "---------------------- verificado -> posTest ("<<x <<","<<y<<")  distQuad = "<<distT<<endl;
				*xdest = x;
				*ydest = y;
				return 1;
			}
			
	}
	return 0;
}

/* Retorna verdadeiro se acerta inimigo atirando na direção x y */
int Generale::isAttac(int idAmico, int idNemico, int x, int y){
	
	int dx, dy, pAx, pAy, pNx, pNy;  

	int n, k, xk, yk, hk, hini, alt, obj, hNemico; 
		
	this->amico[idAmico]->getPos(&pAx, &pAy);
	this->nemico[idNemico]->getPos(&pNx, &pNy); 

	dx = x - pAx;
	dy = y - pAy; //cerr<< "XX  posAmico ("<<pAx <<","<<pAy<<") --------- posNemoco (" <<pNx <<","<<pNy<< ")   dx/dy  "<<dx<<"/"<<dy<<endl;

	n = max(dx>0?dx:-dx, dy>0?dy:-dy); // cerr<< "XX  posTest ("<<x <<","<<y<<")" << " passos n= "<< n <<endl;

	if( this->amico[idAmico]->getStand() ) hini = 9; else hini = 6;
	if( this->nemico[idNemico]->getStand() ) hNemico = 9; else hNemico = 6;

	for(int k= 1; k<= n; k++){

		xk = roundthis(pAx + (float)(k*dx)/n);
		yk = roundthis(pAy + (float)(k*dy)/n);
		hk = hini - roundthis((float)(9*k)/n);

		obj = ground[xk][yk];
		alt= height[xk][yk] != -1 ? alt=height[xk][yk]: 3;
		
		if( (hk - alt) >= 0 ){
			if (obj == GROUND_TREE || obj == GROUND_SMR || obj == GROUND_SMB ) return 0;
			else if( obj == GROUND_AMICO ){
				int id = getIdAmicoPos(xk, yk), hA;
				if( id == -1 ) return 0;
				if( this->amico[id]->getStand() ) hA = 9; else hA = 6;
				if( hk <= hA ) return 0;
			}			
			else if( xk == pNx && yk == pNy){ if( hk <= hNemico)  return k; else return 0; }
			else if( hk - alt == 0) return 0;
		} else 	return 0;
	}
	return 0;
}

int  Generale::isNemicoAttac(int idAmico, int idNemico){

	float dx, dy, dxt, dyt; 
	int pAx, pAy, pNx, pNy;  
	int n, k, xk, yk, hk, obj; 
		
	this->amico[idAmico]->getPos(&pAx, &pAy);
	this->nemico[idNemico]->getPos(&pNx, &pNy); 

	dx = pNx - pAx;
	dy = pNy - pAy; 

	n = max(dx>0?dx:-dx, dy>0?dy:-dy); 

	if( this->nemico[idNemico]->getStand() )
		if( round(sqrt(dx*dx+dy*dy)) > 16 ) return 0;
	else 
		if( round(sqrt(dx*dx+dy*dy)) > 8 ) return 0;
	
	for( dyt = dy-0.3; dyt <= (dy+0.3) ; dyt+=0.3)
		for( dxt = dx-0.3; dxt <= (dx+0.3) ; dxt+=0.3)
			for(int k= 1; k< n; k++){

				xk = roundthis(pAx + (float)(k*dx)/n);
				yk = roundthis(pAy + (float)(k*dy)/n);
				obj = ground[xk][yk];
				
				if (obj == GROUND_TREE || obj == GROUND_SMR || obj == GROUND_SMB || obj == GROUND_NEMICO ) return 0;
				else if( obj == GROUND_AMICO ){
					int id = getIdAmicoPos(xk, yk), hA;
					if( id != -1 ) 	if( this->amico[id]->getStand() ) return 0;
				}			
					
	}
	return 1;
}
/* x y recebe a posicao do obj mais perto do ponto a b do centro de um quadrado de lado 2r */ 
/*int  Generale::isNear (int* x, int* y, int a, int b, int obj, int r){
	int achou= 0;	
	*x = *y = SIZE+SIZE+1;
	

	if ( obj == GROUND_NEMICO ){

		int a_menor = 9999;
		for (int i=0; i< CCOUNT; i++){
			if ( nemico[i].x != -1 ){
				int dist = (nemico[i]->x-a)*(nemico[i]->x-a) + (nemico[i]->y-b)*(nemico[i].y-b);
				if	( ( dist < a_menor ) && ( nemico[i].isAttaccato || !achou ) ){
					a_menor = dist;
					*x = nemico[i].x;
					*y = nemico[i].y;
					achou = 1;
				}
			}
		}

	} else {

		for( int yy = maior(0, b-r), yFim = menor(SIZE, b+r); yy < yFim; yy++){ 

			for(int xx = maior(0, a-r), xFim = menor(SIZE, a+r); xx < xFim; xx++){
			
				if( obj == ground[xx][yy] && !((xx == a) && (yy== b )) &&
					(((*y-b) * (*y-b) + (*x-a) * (*x-a)) > ((xx-a)*(xx-a) + (yy-b)*(yy-b))) ){
					*y=yy;
					*x=xx;
					achou = 1;
				}
			}
		}

	}

	return achou; 
}*/


/* x y recebe a posicao do obj mais perto do ponto a b do centro de um quadrado de lado 2r */ 
/*int  Generale::isNearNemico (int* x, int* y, int a, int b, int *id_nem, int r){
	int achou= 0;		
	int a_menor = 9999;
	for (int i=0; i< CCOUNT; i++){
		if ( nemico[i].x != -1 ){
			int dist = (int) sqrt ((nemico[i].x-a)*(nemico[i].x-a) + (nemico[i].y-b)*(nemico[i].y-b));
			if	( ( dist <= a_menor ) && ( !nemico[i].isAttaccato || !achou ) ){
				a_menor = dist;
				*x = nemico[i].x;
				*y = nemico[i].y;
				*id_nem = i;
				achou = 1;
			}
		}
	}
cerr << "escolhido: " <<  *id_nem << endl;
	return achou; 
}*/


/* Calcula os indices dos inimigos */ 
/*void  Generale::calc_nemico (){
	int i;
	for (i=0; i<CCOUNT; i++){
		if (nemico[i].x == -1)
			con_nemico->setValor (i,0,-1);
		else if (nemico[i].dazed)
			con_nemico->setValor (i,0,5);
		else
			con_nemico->setValor (i,0,10);
	}
}*/


Nemico* Generale::getNemico (unsigned int i){
	if ( i < CCOUNT)
		return nemico[i];
	else
		return nemico[0];
}

int  Generale::getTurn (){
	return turn;
}

char Generale::getHeight (unsigned int x, unsigned int y){
	if ( x < SIZE && y < SIZE )
		return height[x][y];
	return 0;
}

char Generale::setHeight (unsigned int x, unsigned int y, int height){
	if ( x < SIZE && y < SIZE )
		this->height[x][y] = height;
}    

char Generale::getGround (unsigned int x, unsigned int y){
	if ( x < SIZE && y < SIZE )
		return ground[x][y];
	return 0;
}

char Generale::setGround (unsigned int x, unsigned int y, int ground){
	if ( x < SIZE && y < SIZE )
		this->ground[x][y] = ground;
}



int Generale::getNemicoDist(unsigned int i, int x, int y){
	float dist;
	int nX, nY;
	nemico[i]->getPos (&nX, &nY);
	if ( i < CCOUNT && nX != -1)
		return dist = sqrt ((nX-x)*(nX-x) + (nY-y)*(nY-y));
	else
		return -1;
}

int Generale::getAmicoDist(unsigned int i, int x, int y){
	float dist;
	int nX, nY;
	amico[i]->getPos (&nX, &nY);
	return dist = sqrt ((nX-x)*(nX-x) + (nY-y)*(nY-y));
}

int  Generale::getIdAmicoPos(int x, int y){
	int nX, nY, i;
	
	for( i= 0; i< CCOUNT; i++){
		amico[i]->getPos (&nX, &nY);
		if( nX == x && nY == y ) return i;
	}
	
	return -1;
}

int  Generale::getVarPeso (){
	return varpeso;
}

int  Generale::getForcaAliada (){
	return forcaaliada;
}

int  Generale::getForcaInimiga (){
	return forcainimiga;
}

int Generale::roundthis( float x ){ if( x < 0 ) return -(int)round(-x); return (int)round(x); } 
int Generale::maior(int x, int y){ if( x > y ) return x; return y; }
int Generale::menor(int x, int y){ if( x < y ) return x; return y; }
/*--------------------------------------------------------------------------------------*/





