#ifndef GENERALE_H
#define GENERALE_H


#include "Const.h"
#include "Soldato.h"
#include "Controllabili.h"
#include "Nemico.h"
#include "Conjunto.h"

class Generale {
	protected:
		int turn, pc;
		int score[2];
		int redConquista, redBatalha;
		int blueConquista, blueBatalha;
		int forcaaliada, forcainimiga, varpeso;
		char height[SIZE][SIZE];
		char ground[SIZE][SIZE];
		Controllabili *amico[CCOUNT];
		Nemico *nemico [CCOUNT];


	public:
		Generale ();

		int readTurn ();			// Lê o turno do Programa icypc.jar
		void readInfo ();			// Lê as Informações do Programa icypc.jar
		void analise ();			// Analise o Campo e seta as ordens a serem enviadas ao icypc.jar
		void writeInfo ();		// Envia os Comandos para Programa icypc.jar


		Nemico* getNemico (unsigned int i);
		int  getTurn ();		

		char getHeight (unsigned int x, unsigned int y);
		char setHeight (unsigned int x, unsigned int y, int height);    
		char getGround (unsigned int x, unsigned int y);
		char setGround (unsigned int x, unsigned int y, int ground);


		int  getNemicoDist(unsigned int i, int x, int y);
		int  getAmicoDist (unsigned int i, int x, int y);
		int  getIdAmicoPos(int x, int y);  //Retorna Id do amico da posicao x e y              

		int  getVarPeso ();						// Retorna um valor aleatorio
		int  getForcaAliada ();					// Retorna um valor correspondendo a força do time aliado
		int  getForcaInimiga ();				// Retorna a força do time inimigo

		int  isPickup (unsigned int x,unsigned int y);	// Retona se pode ou nao pode pegar neve no local x e y
		int  isMove (unsigned int x, unsigned int y);	// Retona se pode ou nao se mover para o local x e y
		int  isNear (int* x, int* y, int a, int b, int obj, int r); //  em x y recebe obj mais perto dentro de um 'raio d' do ponto a b
		int  isNearNemico (int* x, int* y, int a, int b, int *id_nem, int r);
		int  isAttac(int idAmico, int idNemico, int x, int y);
		int  deffAttac(int idAmico, int idNemico, int* x, int *y);
		int  isNemicoAttac(int idAmico, int idNemico);
		
		int roundthis( float x ); //Arredonda valores negativos para simetria entre jogadores
		int maior(int x, int y); // Retorna o maior
		int menor(int x, int y); // Retorna o menor



};



#endif
